// This file is generated by kconfig_compiler from synaptiks.kcfg.
// All changes you do to this file will be lost.
#ifndef SYNAPTIKS_SYNAPTIKSCONFIGURATION_H
#define SYNAPTIKS_SYNAPTIKSCONFIGURATION_H

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

namespace synaptiks {

class SynaptiksConfiguration : public KConfigSkeleton
{
  public:
    enum IgnoreKeys { IgnoreNoKeys, IgnoreModifierKeys, IgnoreModifierCombos };
    enum TouchpadState { UnchangedState, OnState, OffState };
    enum CircularScrollingTrigger { AnyEdgeTrigger, TopEdgeTrigger, TopRightCornerTrigger, RightEdgeTrigger, BottomRightCornerTrigger, BottomEdgeTrigger, BottomLeftCornerTrigger, LeftEdgeTrigger, TopLeftCornerTrigger };
    enum MouseButton { NoButton, LeftMouseButton, MiddleMouseButton, RightMouseButton };
    class EnumCorner
    {
      public:
      enum type { RightTop, RightBottom, LeftTop, LeftBottom, COUNT };
      static const char* const enumToString[];
    };
    class EnumFinger
    {
      public:
      enum type { One, Two, Three, COUNT };
      static const char* const enumToString[];
    };

    SynaptiksConfiguration( );
    ~SynaptiksConfiguration();

    /**
      Set Automatically switch off touchpad if a mouse is plugged
in
    */
    void setSwitchOffIfMouseIsPlugged( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "SwitchOffIfMouseIsPlugged" ) ))
        mSwitchOffIfMouseIsPlugged = v;
    }

    /**
      Get Automatically switch off touchpad if a mouse is plugged
in
    */
    bool switchOffIfMouseIsPlugged() const
    {
      return mSwitchOffIfMouseIsPlugged;
    }

    /**
      Set A list of mouse devices to be ignored
    */
    void setIgnoredMouseDevices( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "IgnoredMouseDevices" ) ))
        mIgnoredMouseDevices = v;
    }

    /**
      Get A list of mouse devices to be ignored
    */
    QStringList ignoredMouseDevices() const
    {
      return mIgnoredMouseDevices;
    }

    /**
      Set Automatically switch off touchpad, if the user starts
typing
    */
    void setSwitchOffOnKeyboardActivity( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "SwitchOffOnKeyboardActivity" ) ))
        mSwitchOffOnKeyboardActivity = v;
    }

    /**
      Get Automatically switch off touchpad, if the user starts
typing
    */
    bool switchOffOnKeyboardActivity() const
    {
      return mSwitchOffOnKeyboardActivity;
    }

    /**
      Set Ignore these keys when monitoring the keyboard
    */
    void setKeysToIgnore( int v )
    {
      if (!isImmutable( QString::fromLatin1( "KeysToIgnore" ) ))
        mKeysToIgnore = v;
    }

    /**
      Get Ignore these keys when monitoring the keyboard
    */
    int keysToIgnore() const
    {
      return mKeysToIgnore;
    }

    /**
      Set Time in seconds to wait before switching on the touchpad, if
typing stopped.  Fractions of seconds are supported up to millisecond
precision.
    */
    void setIdleTime( double v )
    {
      if (v < 0)
      {
        kDebug() << "setIdleTime: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 10)
      {
        kDebug() << "setIdleTime: value " << v << " is greater than the maximum value of 10";
        v = 10;
      }

      if (!isImmutable( QString::fromLatin1( "IdleTime" ) ))
        mIdleTime = v;
    }

    /**
      Get Time in seconds to wait before switching on the touchpad, if
typing stopped.  Fractions of seconds are supported up to millisecond
precision.
    */
    double idleTime() const
    {
      return mIdleTime;
    }

    /**
      Set Used by the daemon to avoid repeated error messages on systems
with no configurable touchpad.
    */
    void setTouchpadNotSupported( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "TouchpadNotSupported" ) ))
        mTouchpadNotSupported = v;
    }

    /**
      Get Used by the daemon to avoid repeated error messages on systems
with no configurable touchpad.
    */
    bool touchpadNotSupported() const
    {
      return mTouchpadNotSupported;
    }

    /**
      Set The initial state of the touchpad at daemon startup.  Change
this to forcibly enable or disable the touchpad.
    */
    void setTouchpadStateAtStartup( int v )
    {
      if (!isImmutable( QString::fromLatin1( "TouchpadStateAtStartup" ) ))
        mTouchpadStateAtStartup = v;
    }

    /**
      Get The initial state of the touchpad at daemon startup.  Change
this to forcibly enable or disable the touchpad.
    */
    int touchpadStateAtStartup() const
    {
      return mTouchpadStateAtStartup;
    }

    /**
      Set If true, the driver considers the touchpad as circular
touchpad.  Enable this, if the touchpad is circular.
    */
    void setCircularTouchpad( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CircularTouchpad" ) ))
        mCircularTouchpad = v;
    }

    /**
      Get If true, the driver considers the touchpad as circular
touchpad.  Enable this, if the touchpad is circular.
    */
    bool circularTouchpad() const
    {
      return mCircularTouchpad;
    }

    /**
      Set Minimum cursor motion speed
    */
    void setMinimumSpeed( double v )
    {
      if (v < 0)
      {
        kDebug() << "setMinimumSpeed: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 2)
      {
        kDebug() << "setMinimumSpeed: value " << v << " is greater than the maximum value of 2";
        v = 2;
      }

      if (!isImmutable( QString::fromLatin1( "MinimumSpeed" ) ))
        mMinimumSpeed = v;
    }

    /**
      Get Minimum cursor motion speed
    */
    double minimumSpeed() const
    {
      return mMinimumSpeed;
    }

    /**
      Set Maximum cursor motion speed
    */
    void setMaximumSpeed( double v )
    {
      if (v < 0)
      {
        kDebug() << "setMaximumSpeed: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 2)
      {
        kDebug() << "setMaximumSpeed: value " << v << " is greater than the maximum value of 2";
        v = 2;
      }

      if (!isImmutable( QString::fromLatin1( "MaximumSpeed" ) ))
        mMaximumSpeed = v;
    }

    /**
      Get Maximum cursor motion speed
    */
    double maximumSpeed() const
    {
      return mMaximumSpeed;
    }

    /**
      Set Acceleration factor between MinimumSpeed and
MaximumSpeed
    */
    void setAccelerationFactor( double v )
    {
      if (v < 0)
      {
        kDebug() << "setAccelerationFactor: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 1)
      {
        kDebug() << "setAccelerationFactor: value " << v << " is greater than the maximum value of 1";
        v = 1;
      }

      if (!isImmutable( QString::fromLatin1( "AccelerationFactor" ) ))
        mAccelerationFactor = v;
    }

    /**
      Get Acceleration factor between MinimumSpeed and
MaximumSpeed
    */
    double accelerationFactor() const
    {
      return mAccelerationFactor;
    }

    /**
      Set Enable edge motion for all movements, not only for
drags
    */
    void setEdgeMotionAlways( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "EdgeMotionAlways" ) ))
        mEdgeMotionAlways = v;
    }

    /**
      Get Enable edge motion for all movements, not only for
drags
    */
    bool edgeMotionAlways() const
    {
      return mEdgeMotionAlways;
    }

    /**
      Set Enable or disable circular scrolling
    */
    void setCircularScrolling( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CircularScrolling" ) ))
        mCircularScrolling = v;
    }

    /**
      Get Enable or disable circular scrolling
    */
    bool circularScrolling() const
    {
      return mCircularScrolling;
    }

    /**
      Set These touchpad areas trigger circular scrolling
    */
    void setCircularScrollingTrigger( int v )
    {
      if (!isImmutable( QString::fromLatin1( "CircularScrollingTrigger" ) ))
        mCircularScrollingTrigger = v;
    }

    /**
      Get These touchpad areas trigger circular scrolling
    */
    int circularScrollingTrigger() const
    {
      return mCircularScrollingTrigger;
    }

    /**
      Set The move angle of the finger (in degrees) to generate a scroll
event in circular scrolling mode.  The greater the angle, the slower
circular scrolling gets.
    */
    void setCircularScrollingDistance( double v )
    {
      if (v < 0.0)
      {
        kDebug() << "setCircularScrollingDistance: value " << v << " is less than the minimum value of 0.0";
        v = 0.0;
      }

      if (v > 360.0)
      {
        kDebug() << "setCircularScrollingDistance: value " << v << " is greater than the maximum value of 360.0";
        v = 360.0;
      }

      if (!isImmutable( QString::fromLatin1( "CircularScrollingDistance" ) ))
        mCircularScrollingDistance = v;
    }

    /**
      Get The move angle of the finger (in degrees) to generate a scroll
event in circular scrolling mode.  The greater the angle, the slower
circular scrolling gets.
    */
    double circularScrollingDistance() const
    {
      return mCircularScrollingDistance;
    }

    /**
      Set Enable horizontal scrolling with two fingers
    */
    void setHorizontalTwoFingerScrolling( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "HorizontalTwoFingerScrolling" ) ))
        mHorizontalTwoFingerScrolling = v;
    }

    /**
      Get Enable horizontal scrolling with two fingers
    */
    bool horizontalTwoFingerScrolling() const
    {
      return mHorizontalTwoFingerScrolling;
    }

    /**
      Set Enable vertical scrolling with two fingers
    */
    void setVerticalTwoFingerScrolling( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "VerticalTwoFingerScrolling" ) ))
        mVerticalTwoFingerScrolling = v;
    }

    /**
      Get Enable vertical scrolling with two fingers
    */
    bool verticalTwoFingerScrolling() const
    {
      return mVerticalTwoFingerScrolling;
    }

    /**
      Set Enable horizontal scrolling at the bottom edge
    */
    void setHorizontalEdgeScrolling( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "HorizontalEdgeScrolling" ) ))
        mHorizontalEdgeScrolling = v;
    }

    /**
      Get Enable horizontal scrolling at the bottom edge
    */
    bool horizontalEdgeScrolling() const
    {
      return mHorizontalEdgeScrolling;
    }

    /**
      Set Enable vertical scrolling at the right edge
    */
    void setVerticalEdgeScrolling( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "VerticalEdgeScrolling" ) ))
        mVerticalEdgeScrolling = v;
    }

    /**
      Get Enable vertical scrolling at the right edge
    */
    bool verticalEdgeScrolling() const
    {
      return mVerticalEdgeScrolling;
    }

    /**
      Set Continue edge scrolling automatically.
    */
    void setCoasting( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "Coasting" ) ))
        mCoasting = v;
    }

    /**
      Get Continue edge scrolling automatically.
    */
    bool coasting() const
    {
      return mCoasting;
    }

    /**
      Set Continue edge scrolling while the finger stays in an edge
corner.  Coasting must be enabled.
    */
    void setCornerCoasting( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CornerCoasting" ) ))
        mCornerCoasting = v;
    }

    /**
      Get Continue edge scrolling while the finger stays in an edge
corner.  Coasting must be enabled.
    */
    bool cornerCoasting() const
    {
      return mCornerCoasting;
    }

    /**
      Set Set threshold speed for conventional coasting.
    */
    void setCoastingSpeed( double v )
    {
      if (v < 0.01)
      {
        kDebug() << "setCoastingSpeed: value " << v << " is less than the minimum value of 0.01";
        v = 0.01;
      }
      if (!isImmutable( QString::fromLatin1( "CoastingSpeed" ) ))
        mCoastingSpeed = v;
    }

    /**
      Get Set threshold speed for conventional coasting.
    */
    double coastingSpeed() const
    {
      return mCoastingSpeed;
    }

    /**
      Set The move distance of the finger to generate a horizontal
scrolling event.
    */
    void setHorizontalScrollingDistance( int v )
    {
      if (!isImmutable( QString::fromLatin1( "HorizontalScrollingDistance" ) ))
        mHorizontalScrollingDistance = v;
    }

    /**
      Get The move distance of the finger to generate a horizontal
scrolling event.
    */
    int horizontalScrollingDistance() const
    {
      return mHorizontalScrollingDistance;
    }

    /**
      Set The move distance of the finger to generate a vertical
scrolling event.
    */
    void setVerticalScrollingDistance( int v )
    {
      if (!isImmutable( QString::fromLatin1( "VerticalScrollingDistance" ) ))
        mVerticalScrollingDistance = v;
    }

    /**
      Get The move distance of the finger to generate a vertical
scrolling event.
    */
    int verticalScrollingDistance() const
    {
      return mVerticalScrollingDistance;
    }

    /**
      Set Minimum pressure to emulate a two-finger press
    */
    void setTwoFingerEmulationMinimumPressure( int v )
    {
      if (!isImmutable( QString::fromLatin1( "TwoFingerEmulationMinimumPressure" ) ))
        mTwoFingerEmulationMinimumPressure = v;
    }

    /**
      Get Minimum pressure to emulate a two-finger press
    */
    int twoFingerEmulationMinimumPressure() const
    {
      return mTwoFingerEmulationMinimumPressure;
    }

    /**
      Set Minimum width to emulate a two-finger press
    */
    void setTwoFingerEmulationMinimumWidth( int v )
    {
      if (!isImmutable( QString::fromLatin1( "TwoFingerEmulationMinimumWidth" ) ))
        mTwoFingerEmulationMinimumWidth = v;
    }

    /**
      Get Minimum width to emulate a two-finger press
    */
    int twoFingerEmulationMinimumWidth() const
    {
      return mTwoFingerEmulationMinimumWidth;
    }

    /**
      Set $(Corner)CornerButton
    */
    void setCornerButton( int i, int v )
    {
      if (!isImmutable( QString::fromLatin1( "%1CornerButton" ).arg( QLatin1String( EnumCorner::enumToString[i] ) ) ))
        mCornerButton[i] = v;
    }

    /**
      Get $(Corner)CornerButton
    */
    int cornerButton( int i ) const
    {
      return mCornerButton[i];
    }

    /**
      Set $(Finger)FingerButton
    */
    void setFingerButton( int i, int v )
    {
      if (!isImmutable( QString::fromLatin1( "%1FingerButton" ).arg( QLatin1String( EnumFinger::enumToString[i] ) ) ))
        mFingerButton[i] = v;
    }

    /**
      Get $(Finger)FingerButton
    */
    int fingerButton( int i ) const
    {
      return mFingerButton[i];
    }

    /**
      Set Enable fast tapping
    */
    void setFastTaps( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "FastTaps" ) ))
        mFastTaps = v;
    }

    /**
      Get Enable fast tapping
    */
    bool fastTaps() const
    {
      return mFastTaps;
    }

    /**
      Set Enable the tap-and-drag gesture, which enables dragging by
tapping the touchpad and immediately moving finger on the
touchpad.
    */
    void setTapAndDragGesture( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "TapAndDragGesture" ) ))
        mTapAndDragGesture = v;
    }

    /**
      Get Enable the tap-and-drag gesture, which enables dragging by
tapping the touchpad and immediately moving finger on the
touchpad.
    */
    bool tapAndDragGesture() const
    {
      return mTapAndDragGesture;
    }

    /**
      Set If true, a tap-and-drag gesture will remain active, if the
finger is released, until the touchpad is touched again or the timeout
expires.
    */
    void setLockedDrags( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "LockedDrags" ) ))
        mLockedDrags = v;
    }

    /**
      Get If true, a tap-and-drag gesture will remain active, if the
finger is released, until the touchpad is touched again or the timeout
expires.
    */
    bool lockedDrags() const
    {
      return mLockedDrags;
    }

    /**
      Set The timeout of a locked drag to expire in seconds.
    */
    void setLockedDragsTimeout( double v )
    {
      if (v < 0)
      {
        kDebug() << "setLockedDragsTimeout: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 5)
      {
        kDebug() << "setLockedDragsTimeout: value " << v << " is greater than the maximum value of 5";
        v = 5;
      }

      if (!isImmutable( QString::fromLatin1( "LockedDragsTimeout" ) ))
        mLockedDragsTimeout = v;
    }

    /**
      Get The timeout of a locked drag to expire in seconds.
    */
    double lockedDragsTimeout() const
    {
      return mLockedDragsTimeout;
    }

  protected:

    // Automatic Touchpad control
    bool mSwitchOffIfMouseIsPlugged;
    QStringList mIgnoredMouseDevices;
    bool mSwitchOffOnKeyboardActivity;
    int mKeysToIgnore;
    double mIdleTime;

    // General
    bool mTouchpadNotSupported;
    int mTouchpadStateAtStartup;
    bool mCircularTouchpad;

    // Motion
    double mMinimumSpeed;
    double mMaximumSpeed;
    double mAccelerationFactor;
    bool mEdgeMotionAlways;

    // Scrolling
    bool mCircularScrolling;
    int mCircularScrollingTrigger;
    double mCircularScrollingDistance;
    bool mHorizontalTwoFingerScrolling;
    bool mVerticalTwoFingerScrolling;
    bool mHorizontalEdgeScrolling;
    bool mVerticalEdgeScrolling;
    bool mCoasting;
    bool mCornerCoasting;
    double mCoastingSpeed;
    int mHorizontalScrollingDistance;
    int mVerticalScrollingDistance;
    int mTwoFingerEmulationMinimumPressure;
    int mTwoFingerEmulationMinimumWidth;

    // Tapping
    int mCornerButton[4];
    int mFingerButton[3];
    bool mFastTaps;
    bool mTapAndDragGesture;
    bool mLockedDrags;
    double mLockedDragsTimeout;

  private:
};

}

#endif

